 
/*********************************************************************************
*
*			 - 
*
**********************************************************************************
*
*	    :   
* ..  : 1 - 1,     0,01.
*     :
*  ,  ,   ,   :
*C=Q/U;  Q=I*t;  U  I - ,     
*  ,   -  .
*  	      ,
*   ,      .
*
**********************************************************************************
*
*		 PIC16f876A, Fosc=11,0592 MHZ, I.= 0,6912A/
*
*********************************************************************************/

#include <pic.h>
#include <math.h>

__CONFIG(DEBUGDIS & UNPROTECT & LVPDIS & BORDIS & PWRTEN & WDTDIS & HS & DUNPROT);

#define U 1000						//(. )
#define I_min 372						// .    --- ---        
#define MAX 200000					//  
#define DELAY 65000					// 										
#define NUM_OF_BITS 3					//  
#define BITNUM(adr,bit) ((unsigned)(&adr)*8+(bit))	// -
#define ADR1 0x10						// 1-.  -   
#define ADR2 0x11						// ---  2- ---    ---

static bit OUTI1		@ BITNUM(PORTC,1);	//.  0,6912
static bit OUTI2		@ BITNUM(PORTC,0);	// --   --  0,6912
static bit REZET		@ BITNUM(PORTC,2);	// 
static bit THOUSAND	@ BITNUM(PORTC,6);	// "*1000"
static bit ON		@ BITNUM(PORTC,3);	//.  ""
static bit TEN		@ BITNUM(PORTC,4);	// -    ---    ""
static bit HUND		@ BITNUM(PORTC,5);	// -    ---    ""
static bit POINT		@ BITNUM(PORTB,3);	// .
static bit RUN		@ BITNUM(PORTC,7);	// "" 
static bit SW_UP		@ BITNUM(PORTA,1);	// "+"
static bit SW_DWN		@ BITNUM(PORTA,2);	// ---   "-"
static bit SW_M		@ BITNUM(PORTA,5);	// ---   ""

//PORTB -  
//RA0   -   
//RA3   -   
					
unsigned char ONES=0;					// - ,
unsigned char TENS=0;					//  ---     - 
unsigned char HUNDREDS=0;				//  ---     - 
unsigned char BCD=0;					//- 
unsigned char CNT=0;					//  
unsigned char SEGM=0xff;				// 
unsigned char P_ON;					//   
unsigned char P_T;					// ---        ---  
unsigned char P_H;					// ---        ---  
unsigned char Cal1=0;					//  1
unsigned char Cal2=0;					// ---           ---        2
unsigned char MODE=0;					// 
unsigned char CAL_M=0;					// ---  
unsigned int  VALUE=0;					//  
unsigned int I=0;						// (. )
unsigned int I1=0;					//  0,6912
unsigned int I2=0;					// ---     --  0,6912
unsigned long t=0;					//
unsigned long C=0;					//
unsigned long  rcnt;					//  
unsigned long MAX_M;					//. .  .  - 

/*********************************************************************************
*
*			main
*
*********************************************************************************/
						
void main(void)
{
CMCON=0b00010001;				//. 1 ., IN->IN+->OUT1=1
CVRCON=0b00100101;			// . .
ADCON1=0b00000111;			//.    
TRISA=0b00101111;				//     
TRISB=TRISC=0;				//     
PORTB=0xff;					// ,
RUN=0;					//. ""   ---  ,
PORTC=0b00111111;				//   
PORTA=0;					//  
OPTION=0b00000101;			// 0 . .:4,..1:64
INTCON=0b11100000;			//..,. .  TMR0 .
Cal1=eeprom_read(ADR1);			// .1  
Cal2=eeprom_read(ADR2);			// ---           --  2 -   ---

/*********************************************************************************
*
*			 
*
*********************************************************************************/

	while(1)
   {
		I1=Cal1+I_min;			//  0,6912 (. )
		I2=Cal2+I_min;			// ---      -- 0,6912  ---
		if(MODE)MAX_M=(MAX*U)/(I1*2);	// .   
		else MAX_M=(MAX*U)/(I2*2);	// .  -  
		
		rcnt=DELAY;				//  	
		while(rcnt--!= 0) 		//    1,2 
		{
			if(SW_M==0)			// ""  - 
			{
				while(SW_M==0);			// 
				CAL_M=1;				//.  
				P_ON=P_T=P_H=1;			//.  .
				while(CAL_M==1)			// 
				{
					rcnt=DELAY/3;		//.  
					while(--rcnt!=0);		// 0,2 
					if(SW_UP==0)Cal1++;	//"+" -  .  - 
					if(SW_DWN==0)Cal1--;	//"-" -   ---  ---
					if(SW_M==0)			// ""  - 
					{
						eeprom_write(ADR1,Cal1);// 
						EEIF=0;			//
						Cal1=eeprom_read(ADR1);	//  
						CAL_M=2;		//   .
					}
					VALUE=Cal1;			//.  -   
				}
				while(SW_M==0);		// 
				rcnt=DELAY/3;		//.  
				while(--rcnt!=0);		//. 0,2  
				while(CAL_M==2)		// 
				{
					P_ON=0;			// .  -   2
					rcnt=DELAY/3;		//.  
					while(--rcnt!=0);		// 0,2 
					if(SW_UP==0)Cal2++;	//"+" -  .  - 
					if(SW_DWN==0)Cal2--;	//"-" -   ---  ---
					if(SW_M==0)			// ""  - 
					{
						eeprom_write(ADR2,Cal2);	// 
						EEIF=0;				//
						Cal2=eeprom_read(ADR2);		//  
						CAL_M=0;				//
					}
					VALUE=Cal2;			//.  -   
				}
				while(SW_M==0);		// 
				rcnt=DELAY/3;		//.  
				while(--rcnt!=0);		//. 0,2  

			}
			VALUE=C;			//  - 
		}

		TMR0=0;			// 
		t=0;				//   
		REZET=1;RUN=1;		//. ,
		if(MODE)OUTI1=0;		//.  
		else OUTI2=0;		// 
		CMIE=1;			//.     

		while(++t<MAX_M);		//,  1,5 

		RUN=0;			//.  
		if(CMIE)			//   1 -   . 
		{
			++MODE;			//     
			if(MODE>2)MODE=0;		//  
			CMIF=1;			//   
		}
	}
}

/*********************************************************************************
*
*			    main
*
**********************************************************************************	
*
*			
*
*********************************************************************************/

void interrupt Capmeter(void)
{

/********************************************************************************/

	if(TMR0IF)			//   0 -   3 
	{
		HUNDREDS=VALUE/100;				//  
		TENS=(VALUE-HUNDREDS*100)/10;			//-
		ONES=(VALUE-HUNDREDS*100)-TENS*10;		// 

		if(CNT>=NUM_OF_BITS)CNT=0;			//   
		switch(CNT)						//:
		{
			case 0:BCD=ONES;ON=0;TEN=1;HUND=1;		//0 - ,
			break;
			case 1:BCD=TENS;ON=1;TEN=0;HUND=1;		//1 - 
			break;
			case 2:BCD=HUNDREDS;ON=1;TEN=1;HUND=0;	//2 - 
		}

		switch(BCD)	//       :
		{		
			case 0:SEGM=0b00011000;				// 0,
			break;
			case 1:SEGM=0b11011011;				// 1,
			break;
			case 2:SEGM=0b10001100;				// 2,
			break;      
			case 3:SEGM=0b10001001;				// 3,
			break;
			case 4:SEGM=0b01001011;				// 4,
			break;
			case 5:SEGM=0b00101001;				// 5,
			break;
			case 6:SEGM=0b00101000;				// 6,
			break;
			case 7:SEGM=0b10011011;				// 7,
			break;
			case 8:SEGM=0b00001000;				// 8,
			break;
			case 9:SEGM=0b00001001;				// 9.
		}
		PORTB=SEGM;				//   
		switch(CNT)									
		{
			case 0:POINT=P_ON;				//.  .
			break;
			case 1:POINT=P_T;					//.  .
			break;
			case 2:POINT=P_H;					//.  .
		}
		CNT++;				//   

		if(CMIE)t+=47;			//   -  

		TMR0IF=0;				//  .
	}

/********************************************************************************/

	if(CMIF)							//  .
	{
		OUTI1=OUTI2=1;					//  .
		REZET=0;						//. 										
		     
		if(MODE){I=I1;THOUSAND=1;}	// / -"*1000" /  .
		else{I=I2;THOUSAND=0;}		//  .

		if(t<MAX_M)	//     -  
		{
		C=I*t/U;	// ,   

		P_ON=P_T=P_H=1;					//. .

		if((C/10000)>0)C=C/100;				//> 0,1/100 -  .  
		else
		if((C/1000)>0){C=C/10;P_T=0;}			//> 0,01/10 -   .
		else
		P_H=0;						// -    .
		}
		if(MODE>1){C=999;P_ON=P_T=P_H=0;}		//> 1 - 
	
		if(t<5)MODE=0;		//    -   	
		VALUE=C;			//  - 														
		t=MAX_M;			//  - 
		
		asm("movf _CMCON,F");	// . .  
		CMIF=0;CMIE=0;		//.   .   .
	}					//  .
}

/*********************************************************************************
*
*			 " - " !?
*
*********************************************************************************/









